///////////////////////////////////////////////////////////////////////////////
//                                                         
// ChainTest.cc
// -------------
// chain class test module
//                                               
// Design and Implementation by Bjoern Lemke               
//                                                         
// (C)opyright 1996 by Bjoern Lemke                        
//
//
///////////////////////////////////////////////////////////////////////////////

#include "Exception.h"
#include "Chain.h"
#include "locale.h"

int main(int argc, char **argv)
{


    int numCheck = 8;
    int checkCount = 1;
    
    try
    {
	
	cout << "1.." << numCheck << endl;
      	
	char *locale = setlocale(LC_ALL, "de_DE.UTF-8");	
	Chain bl("Björn Lemke und Jörg Hürgel");
	
	if ( bl.length() == 31 )	    
	    cout << "ok " << checkCount << " - length" << endl;
	else
	    cout << "not ok " << checkCount << " - length" << endl;
	checkCount++;
	
        if ( bl.visibleLength() == 28 )	    
	    cout << "ok " << checkCount << " - visibleLength" << endl;
	else
	    cout << "not ok " << checkCount << " - visibleLength" << endl;
	checkCount++;
	
	Chain hw("Hugo Walter");
        if ( hw.visibleLength() == 12 )	    
	    cout << "ok " << checkCount << " - visibleLength" << endl;
	else
	    cout << "not ok " << checkCount << " - visibleLength" << endl;
	checkCount++;
	       
	hw.getHashPos(10);
	cout << "ok " << checkCount << " - getHashPos" << endl;
	checkCount++;
		
	Chain s("This is the chain to replace and replace and replaceY");
	Chain pattern("%y%");
	Chain sqlPattern = Chain("^") + pattern + Chain("$");	
	sqlPattern.replaceAll(Chain("%"), Chain(".*"), sqlPattern);
	sqlPattern.replaceAll(Chain("_"), Chain("."), sqlPattern);
       
	cout << "ok " << checkCount << " - replace" << endl;
	checkCount++;

	char buf[20];
	unsigned long l;
	int i;
	float f;
	double d;
	
	Chain s1;
	Chain s2(buf);
	Chain s3(buf, 20);
	Chain s4(s1);
	Chain s5('c');
	Chain s6(l);
	Chain s7(i);
	Chain s8(f);
	Chain s9(d);
	cout << "ok " << checkCount << " - constructors" << endl;
	checkCount++;
	
	Chain s10 = Chain("XXXergoDASDSAY");
	
	if ( s10.cutTrailing(" ").subChain(s10.length()-1,s10.length()-1) == Chain("Y"))
	    cout << "ok " << checkCount << " - cutTrailing/subChain" << endl;
	else
	    cout << "not ok " << checkCount << " - cutTrailing/subChain" << endl;
	checkCount++;

	s10.length();
	s10.toUpper();
	s10.toLower();
	// s10.asInteger();
	// s8.asBool();
	s10.isNum();
	s10.cutTrailing("YYY");
	s10.truncLeft("YYY");
	s10.truncRight("CCC");
	int pos;
	s10.posStr("ergo", pos);
	Chain res;
	s10.replace("A", "B", res);
	
	Chain s11 = Chain("2.345");
	s11.asFloat();
	cout << "ok " << checkCount << " - others" << endl;
	checkCount++;
		

    }
    catch (Exception e)
    {
	Chain msg;
	e.pop(msg);
	cout << "not ok " << checkCount << " - " << msg << endl;
	return 1;
    }
    
    return 0;
       
}

