// ThreadTest.cc
// -------------
// thread class test module
//                                               
// Design and Implementation by Bjoern Lemke               
//                                                         
// (C)opyright 2000 by Bjoern Lemke                        
//
//
///////////////////////////////////////////////////////////////////////////////

#include <unistd.h>
#include <stdlib.h>

#include "Exception.h"
#include "Thread.h"
#include "ThreadLock.h"
#include "Chain.h"

#include "SigHandler.h"

static ThreadLock _lock;
static int counter;

class MyThread : public Thread
{
    
public:
    MyThread() : Thread() {
	
	_lock.init();
	
    }
    
    void* job(void* arg) {

	try {

	    int n = *(int*)arg;      
	    
	    int i=10;
	    while (i>0)
	    {
		_lock.writeLock(100000);
		
		// cout << "Thread " << getTid() << " : Setting  x to " << i << endl;
		_x++;
		// sleep(1);
		
		_lock.unlock();
		i--;

		counter++;
	    }
	}
	catch (Exception e)
	{
	    e.print();
	    cout << "thread failed" << endl;
	}
	
	return NULL;
    } 

private:
    
    int _x;
    
    
};

int main(int argc, char **argv)
{

    int numCheck = 2;
    int checkCount = 1;
    
    try {


	counter = 0;
	
	cout << "1.." << numCheck << endl;
       
	if ( 1 )
	{
	    
	    MyThread myThread;
	    
	}

	cout << "ok " << checkCount << " - constructor" << endl;
	checkCount++;
	
	
	MyThread myThread[100];
	
	long i, num[100], id[100];
	
	for (i=0; i<15; i++) 
	{
	    
	    // myThread.P(); // locking for argument synchronisation
	    
	    num[i]=i;
	    id[i] = myThread[i].start(&num[i]);
	    
	    // cout << "Thread " << id[i] << " started" << endl;       
	    // sleep(1);
	    
	}
	
	
	// myThread.V();
	for (i=0; i<3; i++) 
	    myThread[i].join(id[i]);


	if ( counter == 150 ) 
	    cout << "ok " << checkCount << " - counter matches" << endl;
	else
	    cout << "not ok " << checkCount << " - counter does not match" << endl;
	
	checkCount++;
		
	
    }

    catch (Exception e)
    {

	Chain msg;
	e.pop(msg);
	cout << "not ok " << checkCount << " - " << msg << endl;
	return 1;
    }
    
    return 0;
}

  
